/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

int gcd(int a, int b)
{
    a = abs(a);
    b = abs(b);

    while(b > 0)
    {
        a = a % b;
        swap(a, b);
    }

    return a;
}

struct frac
{
    int p, q;

    frac()
    {
        p = 0;
        q = 1;
    }

    void simplify()
    {
        int d = gcd(p, q);

        if(d > 0)
        {
            p = p / d;
            q = q / d;
        }

        if(q < 0)
        {
            p = -p;
            q = -q;
        }

        if(p == 0)
            q = 1;
    }

    void print()
    {
        printf("%d", p);
        if(q != 1)
            printf("/%d", q);
    }
};

inline frac operator+ (frac a, frac b)
{
    frac r;
    r.p = a.p * b.q + b.p * a.q;
    r.q = a.q * b.q;
    r.simplify();
    return r;
}

inline frac operator* (frac a, frac b)
{
    frac r;
    r.p = a.p * b.p;
    r.q = a.q * b.q;
    r.simplify();
    return r;
}

inline bool operator< (frac a, frac b)
{
    return ((a.p * b.q) < (b.p * a.q));
}

int n, m, i, j, a, b, k;
frac f, f1, f2;
int flag[2510];
vector < vector <frac> > v;

void dfs(int a)
{
    int i;

    //flag[a] = true;

    for(i = 0; i < n; i++)
    {
        if(flag[i] != -1 || v[a][i].p == 0)
            continue;

        flag[i] = a;
        dfs(i);
    }
}

int main()
{
    freopen("resistor.in", "r", stdin);
    freopen("resistor.out", "w", stdout);

    k = 0;
    scanf("%d %d", &n, &m);
    v.resize(n, vector <frac>(n, frac()));
    for(i = 0; i < m; i++)
    {
        scanf("%d %d %d %d", &a, &b, &f.p, &f.q);
        a--;
        b--;
        if(v[a][b].p == 0)
            v[a][b] = v[b][a] = f;
        else
        {
            k++;
            f1 = f * v[a][b];
            f2 = f + v[a][b];
            swap(f2.p, f2.q);
            v[a][b] = v[b][a] = f1 * f2;
        }
    }
    m -= k;

    fill(flag, flag + n, -1);
    flag[0] = 0;
    dfs(0);
    if(flag[n - 1] == -1)
    {
        printf("Zero conductivity\n");
        return 0;
    }

    if(n == 2)
    {
        f = v[0][1];
        f.print();
        printf("\n");
        return 0;
    }

    if(m == n - 1)
    {
        a = n - 1;
        f = frac();
        while(a != 0)
        {
            f = f + v[flag[a]][a];
            a = flag[a];
        }

        f.print();
        printf("\n");
        return 0;
    }

    if(n == 3 && m == 3)
    {
        f = v[0][1] + v[1][2];
        f1 = f * v[0][2];
        f2 = f + v[0][2];
        swap(f2.p, f2.q);
        f = f1 * f2;

        f.print();
        printf("\n");
        return 0;
    }

    return 0;
}








