/* GCC */
#include <fstream>
#include <vector>

using namespace std;

int gcd(int a, int b)
{return b == 0 ? a : gcd(b, a%b);}

struct rational
{
    rational(void) : num(1), den(0)
    {}
    inline void inv(void)
    {swap(num, den);}
    void add(const rational& rhs)
    {
        int new_num = num*rhs.den + den*rhs.num, new_den = den*rhs.den;
        int g = gcd(new_num, new_den);
        num = new_num/g, den = new_den/g;
    }
    int num, den;
};

bool used[2501] = {};
rational gr[2501][2501];
rational r, r2;
int m, n, f, s;

void dfs1(int v)
{
    used[v] = true;
    for(int u = 1; u <= n; ++u)
        if(!used[u] && gr[v][u].den != 0)
            dfs1(u);
}

void dfs2(int v)
{
    used[v] = true;
    for(int u = 1; u <= n; ++u)
        if(!used[u] && gr[v][u].num == 0)
            dfs2(u);
}

void dfs3(int v)
{
    int u = 0;
    for(int i = 1; i < n; ++i)
        if(gr[v][i].den != 0)
        {
            u = i;
            int u2 = 0;
            for(int j = 1; j <= n; ++j)
                if(j != v && gr[u][j].den != 0)
                {
                    if(u2 != 0)
                    {
                        u2 = 0;
                        break;
                    }
                    u2 = j;
                }
            if(u2 == 0)
                continue;
            r = gr[v][u];
            r.add(gr[u][u2]);
            r.inv();
            gr[v][u2].inv();
            gr[v][u2].add(r);
            gr[v][u2].inv();
            gr[u2][v] = gr[v][u2];
            gr[v][u] = gr[u][v] = gr[u][u2] = gr[u2][u] = rational();
        }
}

int main()
{
    ios_base::sync_with_stdio(false);
    ifstream in("resistor.in");
    in >> n >> m;
    for(int i = 0; i < m; ++i)
    {
        in >> f >> s >> r.den >> r.num;
        gr[f][s].inv();
        gr[f][s].add(r);
        gr[f][s].inv();
        gr[s][f] = gr[f][s];
    }
    in.close();
    dfs1(1);
    ofstream out("resistor.out");
    if(!used[n])
    {
        out << "Zero conductivity\n";
        out.close();
        return 0;
    }
    for(int i = 1; i <= n; ++i)
        used[i] = false;
    dfs2(1);
    if(used[n])
    {
        out << "0\n";
        out.close();
        return 0;
    }
    for(int i = 1; i <= n; ++i)
        dfs3(i);
    for(int i = 1; i <= n; ++i)
        dfs3(i);
    out << gr[1][n].num;
    if(gr[1][n].den != 1)
        out << '/' << gr[1][n].den;
    out << endl;
    out.close();
    return 0;
}
