/* GCC */

#include <fstream>
#include <vector>
#include <utility>
#include <queue>
#include <algorithm>
using namespace std;

typedef pair<int, int> drib;

#define NAME "resistor"

int nsd(int a, int b)
{
    if (a ==0)
        return b;
    else
        return nsd(b % a, a);
}

drib sum(const drib& s1, const drib& s2)
{
    drib s;
    s.first = s1.first * s2.second + s1.second * s2.first;
    s.second = s1.second * s2.second;
    int t = nsd(s.first, s.second);
    s.first /= t;
    s.second /= t;
    return s;
}

int main()
{
    ifstream fin(NAME ".in");
    ofstream fout(NAME ".out");


    int n, m;
    fin >> n >> m;
    n++;
    vector< vector<drib> > gr;
    for (int i = 0; i < n; ++i)
    {
        gr.push_back(vector<drib> ());
        for (int j = 0; j < n; ++j)
            gr[i].push_back(make_pair(-1, -1));
    }

    for (int i = 0; i < m; ++i)
    {
        int a, b, ch, zn;
        fin >> a >> b >> ch >> zn;
        if (gr[a][b].first == -1)
        {
            int t = nsd(ch, zn);
            gr[a][b].first = gr[b][a].first = ch / t;
            gr[a][b].second = gr[b][a].second = zn / t;
        }
        else
        {
            drib c;
            if (ch == 0 || gr[a][b].first == 0)
            {
                c = make_pair(0, 0);
                continue;
            }
            c = make_pair(ch * gr[a][b].first, ch*gr[a][b].second + zn*gr[a][b].first);
            gr[a][b] = gr[b][a] = c;
            int t = nsd(gr[b][a].first, gr[b][a].second);
            gr[a][b].first = gr[b][a].first = gr[b][a].first / t;
            gr[a][b].second = gr[b][a].second = gr[b][a].second / t;
        }
    }
/*
    for (int i =1;i < n;++i)
    {
        for (int j=1;j<n;++j)
            fout << gr[i][j].first << "/" << gr[i][j].second << " ";
        fout << endl;
    }*/

    vector<drib> dist;
    for (int i = 0; i < n; ++i)
    {
        dist.push_back(drib(0, 1));
    }
    vector<bool> visited(n, false);

    queue<int> q;
    bool exit = false;
    q.push(1);
    while (!q.empty() && !exit)
    {
        int i = q.front();
        q.pop();
        for (int j = 0; j < n; ++j)
        {
            if (gr[i][j].first != -1 && !visited[j])
            {
                q.push(j);
                visited[j] = true;
                dist[j] = sum(dist[i], gr[i][j]);
            }
        }
    }
    if (dist[n-1].first == -1)
        fout << "Zero conductivity\n";
    else if (dist[n-1].second == 1)
        fout << dist[n-1].first << endl;
    else
        fout << dist[n-1].first<< "/" << dist[n-1].second << endl;

    fin.close();
    fout.close();
    return 0;
}
